UnrealTimers = LibStub("AceAddon-3.0"):NewAddon("UnrealTimers", "AceEvent-3.0","AceConsole-3.0","AceTimer-3.0")

local media = LibStub("LibSharedMedia-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("UnrealTimers")
UnrealTimers:Print("Addon Restarted; new options")
UnrealTimers.GoTime = 0
UnrealTimers.timerrun = false
UnrealTimers.profile = {}
UnrealTimers.timetemplate = {}

UnrealTimers.mainframe = CreateFrame("Frame", 'MainFrame', UIParent)
UnrealTimers.mainframe:SetPoint("TOPLEFT", 0, 0)
UnrealTimers.mainframe:SetSize(250, 35)
UnrealTimers.mainframe:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", tile = true, tileSize = 8 })
UnrealTimers.mainframe:SetBackdropColor(0.5, 0.5, 0.5, 0.3)
UnrealTimers.mainframe:SetMovable(true)
UnrealTimers.mainframe:EnableMouse(false)
UnrealTimers.mainframe:RegisterForDrag("LeftButton")
UnrealTimers.mainframe:SetScript("OnDragStart", UnrealTimers.mainframe.StartMoving)
UnrealTimers.mainframe:SetScript("OnDragStop", UnrealTimers.mainframe.StopMovingOrSizing)
UnrealTimers.mainframe.fontname = UnrealTimers.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
UnrealTimers.mainframe.fontname:SetPoint("TOPLEFT", 0, 0)
UnrealTimers.mainframe.fontname:SetText('UnrealTimers')
UnrealTimers.mainframe.fontname:SetTextColor(1, 1, 1, 0.6)
UnrealTimers.mainframe.fontname:SetFont("Fonts\\FRIZQT__.ttf" , 10, "OUTLINE")

UnrealTimers.mainframe.font_timearea_name = UnrealTimers.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
UnrealTimers.mainframe.font_timearea_name:SetPoint("BOTTOMLEFT", 0, 0)
UnrealTimers.mainframe.font_timearea_name:SetText('')
UnrealTimers.mainframe.font_timearea_name:SetTextColor(1, 0, 0)
UnrealTimers.mainframe.font_timearea_name:SetFont("Fonts\\FRIZQT__.ttf" , 16, "OUTLINE")

function UnrealTimers:createoptionmenubar()
	self.mainframe.minibutton = CreateFrame('Button', 'Minimar', UnrealTimers.mainframe)
	self.mainframe.minibutton:SetPoint("TOPRIGHT", -15, 0)
	self.mainframe.minibutton:SetSize(20, 20)
	self.mainframe.minibutton:SetNormalTexture("Interface\\LFGFRAME\\BattlenetWorking4")
	self.mainframe.minibutton:SetScript("OnClick", function(self,event,arg1) 
		if UnrealTimers.allframes:IsShown() then
			UnrealTimers:hidetimers()
		else
			UnrealTimers:showtimers()
		end
	end)
	
	self.mainframe.minibutton2 = CreateFrame('Button', 'Moveable', UnrealTimers.mainframe)
	self.mainframe.minibutton2:SetPoint("TOPRIGHT", 0, 0)
	self.mainframe.minibutton2:SetSize(20, 20)
	self.mainframe.minibutton2:SetNormalTexture("Interface\\Buttons\\LockButton-Unlocked-Down")
	self.mainframe.minibutton2:SetScript("OnClick", function(self,event,arg1) 
		if UnrealTimers.mainframe:IsMouseEnabled() then
			UnrealTimers.mainframe:EnableMouse(false)
			UnrealTimers.mainframe.minibutton2:SetNormalTexture("Interface\\Buttons\\LockButton-Unlocked-Up")			
		else
			UnrealTimers.mainframe:EnableMouse(true)
			UnrealTimers.mainframe.minibutton2:SetNormalTexture("Interface\\Buttons\\LockButton-Unlocked-Down")
		end
	end)
	
end




UnrealTimers.allframes = CreateFrame("Frame", 'Frame1', UnrealTimers.mainframe)
UnrealTimers.allframes:SetPoint("TOPLEFT",  0, -25)
UnrealTimers.allframes:SetSize(1, 1)
UnrealTimers.allframes.button = {}
UnrealTimers.currentCheckPoint = 1
UnrealTimers.localbosskillids = {}

local zone_ids = { -- old!!!! resetbutton
	680, 1046, 1067,1045,1042,1041,1081,1065, 1066
}

local map_ids = {
	1492, 389, 1477, 1456, 1466, 1493, 1501, 1458, 1516, 1571--, 1544
}

local zone_data = {
	[389] = { -- Ragefire
		[1443] = {
			name = L["Adarogg"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Adarogg]],
		},
		[1444] = {
			name = L["Dark Shaman Koranthal"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Dark Shaman Koranthal]],
		},
		[1445] = {
			name = L["Slagmaw"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Magmaw]],
		},
		[1446] = {
			name = L["Lava Guard Gordoth"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Lava Guard Gordoth]],
		},
		['template'] = {
			[1] = {BossID = 1443},
			[2] = {BossID = 1444},
			[3] = {BossID = 1445},
			[4] = {BossID = 1446},
		},
	},
	[1492] = { --Maw of Souls
		[1822] = {
			name = L["Ymiron, the Fallen King"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Ymiron the Fallen King]],
		},
		[1823] = {
			name = L["Harbaron"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Harbaron]],
		},
		[1824] = {
			name = L["Helya"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Helya]],
		},
		['template'] = {
			[1] = {BossID = 1822},
			[2] = {BossID = 1823},
			[3] = {BossID = 1824},
		},
	},
	[1477] = { --Halls of Valor
		[1805] = {
			name = L["Hymdall"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Hymdall]]
		},
		[1806] = {
			name = L["Hyrja"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Hyrja]]
		},
		[1807] = {
			name = L["Fenryr"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Fenryr]]
		},
		[1808] = {
			name = L["God-King Skovald"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-God-King Skovald]],
		},
		[1809] = {
			name = L["Odyn"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Odyn]],
		},
	
		['template'] = {
			[1] = {BossID = 1805},
			[2] = {BossID = 1806},
			[3] = {BossID = 1807},
			[4] = {BossID = 1808},
			[5] = {BossID = 1809},
		},
	},
	[1456] = { --Eye of Azshara
		[1810] = {
			name = L["Warlord Parjesh"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Warlord Parjesh]]
		},
		[1811] = {
			name = L["Lady Hatecoil"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Lady Hatecoil]]
		},
		[1813] = {
			name = L["Serpentrix"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Serpentrix]]
		},
		[1812] = {
			name = L["King Deepbeard"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-King Deepbeard]],
		},
		[1814] = {
			name = L["Wrath of Azshara"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Wrath of Azshara]],
		},
		['template'] = {
			[1] = {BossID = 1810},
			[2] = {BossID = 1811},
			[3] = {BossID = 1813},
			[4] = {BossID = 1812},
			[5] = {BossID = 1814},
		},
	},
	[1466] = { -- Darkheart Thicket
		[1836] = {
			name = L["Archdruid Glaidalis"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Arch-Druid Glaidalis]],
		},
		[1837] = {
			name = L["Oakheart"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Oakheart]],
		},
		[1838] = {
			name = L["Dresaron"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Dresaron]],
		},
		[1839] = {
			name = L["Shade of Xavius"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Shade of Xavius]],
		},
		['template'] = {
			[1] = {BossID = 1836},
			[2] = {BossID = 1837},
			[3] = {BossID = 1838},
			[4] = {BossID = 1839},
		},
	},
	[1493] = { -- Vault of the Wardens
		[1815] = {
			name = L["Tirathon Saltheril"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Tirathon Saltheril]]
		},
		[1850] = {
			name = L["Inquisitor Tormentorum"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Inquisitor Tormentorum]],
		},
		[1816] = {
			name = L["Ash'Golm"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Ashgolm]],
		},
		[1817] = {
			name = L["Glazer"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Glazer]],
		},
		[1818] = {
			name = L["Cordana Felsong"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Cordana]],
		},
	
		['template'] = {
			[1] = {BossID = 1815},
			[2] = {BossID = 1850},
			[3] = {BossID = 1816},
			[4] = {BossID = 1817},
			[5] = {BossID = 1818},
		},
	},
	[1501] = { -- Black Rook Hold
		[1832] = {
			name = L["Amalgam of Souls"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-The Amalgam of Souls]]
		},
		[1833] = {
			name = L["Illysanna Ravencrest"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Illysanna Ravencrest]],
		},
		[1834] = {
			name = L["Smashspite the Hateful"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Smashspite the Hateful]],
		},
		[1835] = {
			name = L["Lord Kur'talos Ravencrest"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Lord Kurtalos Ravencrest]],
		},
		['template'] = {
			[1] = {BossID = 1832},
			[2] = {BossID = 1833},
			[3] = {BossID = 1834},
			[4] = {BossID = 1835},
		},
	},
	[1458] = { -- Neltharion's Lair
		[1790] = {
			name = L["Rokmora"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Rokmora]],
		},
		[1791] = {
			name = L["Ularogg Cragshaper"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Ularogg Cragshaper]],
		},
		[1792] = {
			name = L["Naraxas"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Naraxas]],
		},
		[1793] = {
			name = L["Dargrul"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Dargrul the Underking]],
		},
		['template'] = {
			[1] = {BossID = 1790},
			[2] = {BossID = 1791},
			[3] = {BossID = 1792},
			[4] = {BossID = 1793},
		}
	},
	[1544] = { -- Violet Hold
		[4001] = {
			name = L["Festerface"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Festerface]],
		},
		[4124] = {
			name = L["Shivermaw"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Shivermaw]],
		},
		[4011] = {
			name = L["Blood-Princess Thal'ena"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Blood-Princess Thalena]],
		},
		[3991] = {
			name = L["Mindflayer Kaahrj"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Mindflayer Kaahrj]],
		},
		[3993] = {
			name = L["Millificent Manastorm"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Millificent Manastorm]],
		},
		[4123] = {
			name = L["Anub'esset"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Anubesset]],
		},
		[4003] = {
			name = L["Sael'orn"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Saelorn]],
		},
		[4025] = {
			name = L["Fel Lord Betrug"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Fel Lord Betrug]],
		},
		['template'] = {
			[1] = {BossID = 4001},
			[2] = {BossID = 3991},
			[3] = {BossID = 4025},
		}
	},
	[1516] = { -- The Arcway
		[1827] = {
			name = L["Ivanyr"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Ivanyr]]
		},
		[1825] = {
			name = L["Corstilax"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Corstilax]],
		},
		[1826] = {
			name = L["Nal'tira"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Naltira]],
		},
		[1828] = {
			name = L["General Xakal"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-General Xakal]],
		},
		[1829] = {
			name = L["Advisor Vandros"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Advisor Vandros]],
		},
	
		['template'] = {
			[1] = {BossID = 1828},
			[2] = {BossID = 1826},
			[3] = {BossID = 1825},
			[4] = {BossID = 1827},
			[5] = {BossID = 1829},
		},
	},
	[1571] = { -- Court of Stars
		[1868] = {
			name = L["Patrol Captain Gerdo"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Patrol Captain Gerdo]],
		},
		[1869] = {
			name = L["Talixae Flamewreath"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Talixae Flamewreath]],
		},
		[1870] = {
			name = L["Advisor Melandrus"],
			Texture = [[Interface\EncounterJournal\UI-EJ-BOSS-Advisor Melandrus]],
		},
		['template'] = {
			[1] = {BossID = 1868},
			[2] = {BossID = 1869},
			[3] = {BossID = 1870},
		},
	},
}

local dbDefaults = {
	profile = {	
		lock = true,
		frameheight = 60,
		mainfont = "FORCED SQUARE",
		currentZone = 0,
		newinstancezone = false,
		startcheck = 0,
		currentdata = {}
	}
}


function UnrealTimers:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("UnrealTimersDB", dbDefaults)
end

function UnrealTimers:set_check(bossid)
	local bossid = bossid or 0
	
	if bossid ~= 0 then
		for i, databossid in ipairs(UnrealTimers.localbosskillids) do
			if databossid == bossid then
				--print('boss wipe/reset')
				return
			end
		end
		table.insert(UnrealTimers.localbosskillids , bossid) 
	elseif  UnrealTimers.currentCheckPoint%2 == 0 then
		return
	end
	
	if self.timerrun == true then
		local runningtime = GetTime()-UnrealTimers.GoTime
		if UnrealTimers.currentCheckPoint > 4 then --only 5
			if self.timerrun then
				UnrealTimers.timetemplate[UnrealTimers.currentCheckPoint].time = runningtime
				
				UnrealTimers.currentCheckPoint = UnrealTimers.currentCheckPoint+1 
				
			end
		else --   1-4
			UnrealTimers.timetemplate[UnrealTimers.currentCheckPoint].time = runningtime
			UnrealTimers.currentCheckPoint = UnrealTimers.currentCheckPoint+1 
			UnrealTimers.allframes['frame'..UnrealTimers.currentCheckPoint-1]:SetBackdropColor(0, 0, 0, 0.2)
			UnrealTimers.allframes['frame'..UnrealTimers.currentCheckPoint]:SetBackdropColor(0, 0, 1, 0.2)
			
		end
		if self.timetemplate.endbossid == bossid then --or UnrealTimers.currentCheckPoint > self.getmaxobjectvalueofnumbers(self.profile) then
			self.timestop()
			self.timetemplate.finishtime = runningtime
			self.db.global.ini_logs[self.db.global.inilogsnumbers] = {}
			self.db.global.ini_logs[self.db.global.inilogsnumbers] = self.timetemplate 
			self.db.global.inilogsnumbers = self.db.global.inilogsnumbers+1
			UnrealTimers.allframes['frame5']:SetBackdropColor(0, 0, 0, 0.2)
			print('timestop')
		end
		self:update_timer()
	end
end

function UnrealTimers:timestop()
	UnrealTimers.timerrun = false
end

function UnrealTimers:createsalltemplates()
	self.localtemplates = {}
	for i = 1, self.db.global.inilogsnumbers, 1 do
		if self.db.global.ini_logs[i] then
			if self.db.global.ini_logs[i].instanceMapID then
				if self.localtemplates[self.db.global.ini_logs[i].instanceMapID] ~= nil then
					if self.localtemplates[self.db.global.ini_logs[i].instanceMapID].finishtime   then
						if self.localtemplates[self.db.global.ini_logs[i].instanceMapID].finishtime > self.db.global.ini_logs[i].finishtime then
							--print(self.localtemplates[self.db.global.ini_logs[i].instanceMapID].finishtime)
							--print(self.db.global.ini_logs[i].finishtime)
							self.localtemplates[self.db.global.ini_logs[i].instanceMapID].finishtime = self.db.global.ini_logs[i].finishtime
							local maxskips = self.getmaxobjectvalueofnumbers (self.db.global.ini_logs[i])
							for j = 1, maxskips, 1 do
								self.localtemplates[self.db.global.ini_logs[i].instanceMapID][j].time = self.db.global.ini_logs[i][j].time
							end
						end
					end
				else
					self.localtemplates[self.db.global.ini_logs[i].instanceMapID] = {}
					self.localtemplates[self.db.global.ini_logs[i].instanceMapID].finishtime = self.db.global.ini_logs[i].finishtime
					local maxskips = self.getmaxobjectvalueofnumbers (self.db.global.ini_logs[i])
					for j = 1, maxskips, 1 do
						self.localtemplates[self.db.global.ini_logs[i].instanceMapID][j] = {}
						self.localtemplates[self.db.global.ini_logs[i].instanceMapID][j].time = self.db.global.ini_logs[i][j].time
					end
				end
			end	
		end
	end
end

function UnrealTimers.getmaxobjectvalueofnumbers(object)
	local i = 1
    while object[i] do
      i = i + 1
    end
	return i-1
end

function UnrealTimers:OnEnable()
	if not self.db.global.inilogsnumbers then
		self.db.global.inilogsnumbers = 1
	end 
	if not self.db.global.datalogs then
		self.db.global.datalogs = {}
	end
	if not self.db.global.ini_logs then
		self.db.global.ini_logs = {}
	end
	self:createsalltemplates()
	self:createoptionmenubar()
	self:check_showtimes()
	self.db.profile.currentdata = {}
	self:OnOptionCreate()
	for i = 1, 5, 1 do
		self:createFrame(i, i)
	end
	self:CreateOverallTimeTemplate()
	self:CreateOverallTime()
	--self:CreateButton('Start', function() UnrealTimers:StartTime() end, -25, -440, 150, 40)
	-- self:CreateButton('Stop', function() UnrealTimers.timerrun = false end, 45, -400, 300, 20)
	-- self:CreateButton('Reset', function() UnrealTimers:Reset() end, 125, -440, 150, 40)
	--self:CreateButton('CheckPoint', function() 
		
		--UnrealTimers:set_check() 
		--UnrealTimers:update_timer()
		
	--end, 
	--45, -480, 300, 50)
	self.mainframe:RegisterEvent('ZONE_CHANGED_NEW_AREA')
	self.mainframe:RegisterEvent('ENCOUNTER_START')
	self.mainframe:RegisterEvent('ENCOUNTER_END')
	self.mainframe:RegisterEvent('PLAYER_REGEN_DISABLED')
	self.mainframe:RegisterEvent('PLAYER_REGEN_ENABLED')
	self.mainframe:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
	self.mainframe:SetScript('OnEvent', UnrealTimers_OnEvent)
	local _, _, _, _, _, _, _, instanceMapID, _ = GetInstanceInfo()
	self.db.profile.currentZone = 389
	self:new_timer(389)
	
	self.db.profile.currentZone = instanceMapID
	self:new_timer(self.db.profile.currentZone)
end

function UnrealTimers:Reset()
	if self.timerrun == false then
		local isinarray = self:FindValue(self.db.profile.currentZone , zone_ids)
		if isinarray then
			for i = 1 , 5 , 1 do
				local j = i +0
				self.allframes['frame'..j].fontname:SetText(self:cut_name(zone_data[self.db.profile.currentZone][i]['framename']), 20)
				self.allframes['frame'..j].fonttime:SetText(get_string_Time(zone_data[self.db.profile.currentZone][i]['Time']))
				if zone_data[self.db.profile.currentZone][j]['Texture'] ~= nil then
					self.allframes['frame'..j].tex:Show()
					self.allframes['frame'..j].tex:SetTexture(zone_data[self.db.profile.currentZone][j]['Texture'])
				else 
					--print(j..' is false')
					self.allframes['frame'..j].tex:SetTexture(0,0,0)
				end
			end
		else
			for i = 1 , 5 , 1 do
				local j = i +0
				self.allframes['frame'..j].fontname:SetText('frame'..j)
				self.allframes['frame'..j].fonttime:SetText(0)
				self.allframes['frame'..j].tex:SetTexture(0,0,0)
			end
		end
		UnrealTimers.allframes['overalltime'].fonttime:SetText('0:00.00')
	end
end

function UnrealTimers:check_showtimes()
	local isinarray = self:FindValue(self.db.profile.currentZone , map_ids)
	if isinarray then
		self:showtimers()
	else
		self:hidetimers()
	end
end

function UnrealTimers:showtimers()
	self.allframes:Show()
	self.mainframe.minibutton:SetNormalTexture("Interface\\LFGFRAME\\BattlenetWorking4")
end

function UnrealTimers:hidetimers()
	self.allframes:Hide()
	self.mainframe.minibutton:SetNormalTexture("Interface\\LFGFRAME\\BattlenetWorking0")
end

function UnrealTimers:zone_changed()
	local _, _, _, _, _, _, _, instanceMapID, _ = GetInstanceInfo()
	self.db.profile.currentZone = instanceMapID
	self:check_showtimes()
	--print(GetCurrentMapAreaID())
	--print(GetMapNameByID(GetCurrentMapAreaID()))
	self:new_timer(self.db.profile.currentZone)
	if self.timerrun == false then
		local isinarray = self:FindValue(self.db.profile.currentZone , map_ids)
		if isinarray then
			self.db.profile.newinstancezone = true
			print('new timerun')
		end
	end
end

function UnrealTimers:FindValue(value, dataarray)
	for i, data_value in ipairs(dataarray) do
		if data_value == value then
			return true
		end
	end
end

function UnrealTimers:cut_name(name, ...)
	local max_length = ... or 15
	local length = string.len(name)
	if length > max_length + 2 then
		name = string.sub(name, 0, max_length)
		name = name..".."
	end
	return name
end

function tablelen(tablename)
  local count = 0
  if tablename == nil then return 0 end
  for _ in pairs(tablename) do count = count + 1 end
  return count
end

function UnrealTimers:boss_start(...)
	local creatureid = ...
	--print(...)
	self:set_check()
	local event = 'BOSS_START'
	self:plotlog(event, ...)
end

function UnrealTimers:boss_end(...)
	--print(...)
	local bossid,_,_,_, iskill = ...
	if iskill == 1  then
		self:set_check(bossid)
		local event = 'BOSS_END'
		self:plotlog(event, ...)
	end
end

function UnrealTimers:plotlog(event, ...)
	local insertstring = event
	local thetime = GetTime()
	local thedate = date()
	insertstring = insertstring..' '..thedate
	insertstring = insertstring..' '..thetime
	if event == 'INSTANCE_START' then
		local name, instanceType, difficultyID, difficultyName, maxPlayers, dynamicDifficulty, isDynamic, instanceMapID, instanceGroupSize = GetInstanceInfo()
		insertstring = insertstring..' '..name
		insertstring = insertstring..' '..instanceType
		insertstring = insertstring..' '..difficultyID
		insertstring = insertstring..' '..difficultyName
		insertstring = insertstring..' '..maxPlayers
		insertstring = insertstring..' '..dynamicDifficulty
		if isDynamic then
			insertstring = insertstring..' 1'
		else
			insertstring = insertstring..' 0'
		end
		insertstring = insertstring..' '..instanceMapID
		insertstring = insertstring..' '..instanceGroupSize
		self:new_timer(instanceMapID)
	elseif event == 'BOSS_START' then
		local boosID, bossName, difficultyID, maxPlayers = ...
		insertstring = insertstring..' '..boosID
		insertstring = insertstring..' '..bossName
		insertstring = insertstring..' '..difficultyID
		insertstring = insertstring..' '..maxPlayers
	elseif event == 'BOSS_END' then
		local boosID, bossName, difficultyID, maxPlayers, iskill = ...
		insertstring = insertstring..' '..boosID
		insertstring = insertstring..' '..bossName
		insertstring = insertstring..' '..difficultyID
		insertstring = insertstring..' '..maxPlayers
		insertstring = insertstring..' '..iskill
	else
		print('faillog')
	end
	table.insert(self.db.global.datalogs, insertstring)
end

function UnrealTimers:update_timer()
	local start = self.currentCheckPoint
	
	if start > self.getmaxobjectvalueofnumbers(self.profile)*2+1 then
		--print('ende '..start)
		return
	end
	
	local frame_end = 5
	local frame_start = 1
		
	if start > 4 then
		frame_end = self:get_frame_end(start-4, self.getmaxobjectvalueofnumbers(self.profile)*2)
		frame_start = self:get_frame_start(frame_end)
	end	
	
	local j = 1
	for i = frame_start ,frame_end  , 1 do
		
		self:set_frame_text('frame'..j,  self.timetemplate[i].name)
		self:set_frame_time('frame'..j,  self.timetemplate[i].time)
		self:set_frame_texture('frame'..j, self.timetemplate[i ].tex)
		j = j+1
	end
	
end

function UnrealTimers:new_timer(instanceMapID)
	
	self.profile = {}
	
	local isinarray = self:FindValue(self.db.profile.currentZone , map_ids)
	if isinarray then
		self.profile = zone_data[instanceMapID]['template']
	else
		return
	end
	
	self.allframes['overalltime'].fonttime:SetText('0:00.00')
	
	self.timetemplate = {}
	 
	for  i = 1 , self.getmaxobjectvalueofnumbers(self.profile) , 1 do
		self.timetemplate[i+i-1] = {}
		local trashname = 'Trash \n'
		if i ~= 1 then
			trashname = trashname..self:cut_name(zone_data[instanceMapID][self.profile[i-1].BossID].name, 10)
		else
			trashname = trashname..'Start'
		end
		trashname = trashname..' - '..self:cut_name(zone_data[instanceMapID][self.profile[i].BossID].name, 10)
		self.timetemplate[i+i-1].name = trashname
		self.timetemplate[i+i-1].tex = nil
		self.timetemplate[i+i-1].time = i*400
		self.timetemplate[i*2] = {}
		self.timetemplate[i*2].name = self:cut_name(zone_data[instanceMapID][self.profile[i].BossID].name, 16)
		self.timetemplate[i*2].tex = zone_data[instanceMapID][self.profile[i].BossID].Texture
		self.timetemplate[i*2].time = i*400+200
		self.timetemplate[i*2].bossid = self.profile[i].BossID
	end
	
	--check if real timestoptime
	if self.localtemplates[instanceMapID] then
		local maxskips = self.getmaxobjectvalueofnumbers (self.localtemplates[instanceMapID])
		for i = 1, maxskips, 1 do
			self.timetemplate[i].time = self.localtemplates[instanceMapID][i].time 
		end
	end
	
	self.timetemplate.enbosstime = self.timetemplate[self.getmaxobjectvalueofnumbers(self.timetemplate)].time
	
	local name, instanceType, difficultyID, difficultyName, maxPlayers, dynamicDifficulty, isDynamic, _, instanceGroupSize = GetInstanceInfo()
		
	self.timetemplate.instanceMapID = instanceMapID
	self.timetemplate.name = name
	self.timetemplate.instanceType = instanceType
	self.timetemplate.difficultyID = difficultyID
	self.timetemplate.difficultyName = difficultyName
	self.timetemplate.maxPlayers = maxPlayers
	self.timetemplate.dynamicDifficulty = dynamicDifficulty
	if isDynamic then
		self.timetemplate.isDynamic = 'true'
	else
		self.timetemplate.isDynamic = 'false'
	end
	self.timetemplate.instanceGroupSize = instanceGroupSize
	
	self.timetemplate.endbossid = self.profile[self.getmaxobjectvalueofnumbers(self.profile)].BossID
	
	self.timetemplate.player = {}
	local pname, prealm  = UnitFullName('player')
	self.timetemplate.player.name = pname
	self.timetemplate.player.realm = prealm
	local specializationID = GetInspectSpecialization('player')
	self.timetemplate.player.specializationID = specializationID 
	
	local numGroupMembers = GetNumGroupMembers()
	self.timetemplate.numGroupMembers = numGroupMembers
	-- if numGroupMembers ~= 1 then
		-- print('more one in group: '..numGroupMembers)
		-- for i = 1, numGroupMembers, 1 do
			-- self.timetemplate.player.party[i] = {}
			-- local playername, playerrealm  = UnitFullName('party'..i)
			-- local specializationID = GetInspectSpecialization('party'..i)
			-- self.timetemplate.player.party[i].name = playername
			-- self.timetemplate.player.party[i].realm = playerrealm
			-- self.timetemplate.player.party[i].specializationID = specializationID 
		-- end
	-- end
	
	local _time = GetTime()
	local _date = date()
	self.timetemplate.servertimestart = _time
	self.timetemplate.date = _date
	
	local start = 1
	local frame_end = self:get_frame_end(start, self.getmaxobjectvalueofnumbers(self.profile)*2)
	local frame_start = self:get_frame_start(frame_end)
	
	local j = 1
	for i = frame_start ,frame_end  , 1 do
		
		self:set_frame_text('frame'..j,  self.timetemplate[i].name)
		self:set_frame_time('frame'..j,  self.timetemplate[i].time)
		self:set_frame_texture('frame'..j, self.timetemplate[i].tex)
		j = j+1
	end
	
	self.allframes['overalltimetemplate'].fonttime:SetText(L["Record"]..' = '..get_string_Time(self.timetemplate.enbosstime))
	
	--Toplinetext
	UnrealTimers.mainframe.font_timearea_name:SetText(self.timetemplate.name..' ('..difficultyName..')')
	
	
end

function UnrealTimers:get_frame_start(frame_end)
	if frame_end-5 > 0 then
		return frame_end-4
	else
		return 1
	end
end

function UnrealTimers:get_frame_end(start, bossnumbers)
	if bossnumbers-(start+4) > 0 then
		return start+4
	else
		return bossnumbers
	end
end

function UnrealTimers:set_frame_texture(framename, tex)
	local tex = tex or nil
	if tex then
		self.allframes[framename].tex:Show()
		self.allframes[framename].tex:SetTexture(tex)
	else
		self.allframes[framename].tex:SetTexture(0,0,0)
	end
end

function UnrealTimers:set_frame_time(framename, text)
	self.allframes[framename].fonttime:SetText(get_string_Time(text))
end

function UnrealTimers:set_frame_text(framename, text)
	self.allframes[framename].fontname:SetText(text)
end

function UnrealTimers:update_time()
	
end

function UnrealTimers:check_start()
	if self.db.profile.newinstancezone then
		--print(GetInstanceInfo())
		local event = 'INSTANCE_START'
		self:plotlog(event, 'nil')
		self:StartTime()
		self.db.profile.newinstancezone = false
	end
end



function UnrealTimers_OnEvent(self, event, ...)
	UnrealTimers.mainframe:OnEvent(event, ...)
end

function get_string_Time(value)
	if type(value) ~= 'number' then
		--print(value)
	end
	local runningminmin = tonumber(value) / 60
	runningminmin = math.floor(runningminmin)
	runningminmin = string.format("%.0f", runningminmin)
	value = value % 60
	local is_maxninenine = isoverninenine(value)
	value = string.format("%.1f", value)
	if runningminmin ~= '0' then
		if is_maxninenine then
			value = runningminmin..':0'..value
		else
			value = runningminmin..':'..value
		end
	end
	return value
end

UnrealTimers.mainframe:SetScript("OnUpdate", function(self, frame) 
	if UnrealTimers.timerrun == true then--and self.GoTIme ~= 0 then
		local runningtime = GetTime()-UnrealTimers.GoTime
		UnrealTimers.allframes['overalltime'].fonttime:SetText(get_string_Time(runningtime))
	end
end)

function UnrealTimers:CreateButton(name, onclickfunction, posix, posiy, width, height)
	self.allframes.button[name] = CreateFrame('Button', name, self.mainframe, UIPanelButtonTemplate)
	self.allframes.button[name]:SetPoint("BOTTOM", posix, posiy)
	self.allframes.button[name]:SetSize(width, height)
	self.allframes.button[name]:SetText('Start')
	self.allframes.button[name]:SetBackdrop({
    bgFile = [[Interface\BUTTONS\WHITE8X8]],
		edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]], edgeSize =15,
		tileSize = 16, tile = true,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	self.allframes.button[name]:SetBackdropColor(0.5, 0 ,0)
	self.allframes.button[name].text = self.allframes.button[name]:CreateFontString('hidebuttontext', "OVERLAY", "GameTooltipText")
	self.allframes.button[name].text:SetPoint("Center", 0, 0)
	self.allframes.button[name].text:SetText(name)
	self.allframes.button[name].text:SetFont("Fonts\\FRIZQT__.ttf",20,"OUTLINE")
	self.allframes.button[name]:SetScript("OnClick", function(self,event,arg1) 
		onclickfunction()
	end)
end

function UnrealTimers:CreateOverallTimeTemplate()
	local framename = 'overalltimetemplate'
	self.allframes[framename] = CreateFrame("Frame", framename, self.allframes)
	self.allframes[framename]:SetPoint("TOPLEFT", 0, -self.db.profile.frameheight*(7-1))
	self.allframes[framename]:SetSize(300, self.db.profile.frameheight-5)
	self.allframes[framename]:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8"})
	self.allframes[framename]:SetBackdropColor(0, 1, 0, 0.2)
	self.allframes[framename].fonttime = self.allframes[framename]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.allframes[framename].fonttime:SetPoint("Center", 0, 0)
	self.allframes[framename].fonttime:SetText(L["Record"]..' = 0:00.00')
	self.allframes[framename].fonttime:SetFont(media:Fetch("font", self.db.profile.mainfont) , 25, "OUTLINE")
	self.allframes[framename].fonttime:SetTextColor(1, 1, 1)
end


function UnrealTimers:CreateOverallTime()
	local framename = 'overalltime'
	self.allframes[framename] = CreateFrame("Frame", framename, self.allframes)
	self.allframes[framename]:SetPoint("TOPLEFT", 0, -self.db.profile.frameheight*(6-1))
	self.allframes[framename]:SetSize(300, self.db.profile.frameheight)
	self.allframes[framename]:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8"})
	self.allframes[framename]:SetBackdropColor(0, 0, 0, 0.2)
	self.allframes[framename].fonttime = self.allframes[framename]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.allframes[framename].fonttime:SetPoint("Center", 0, 0)
	self.allframes[framename].fonttime:SetText('0:00.00')
	self.allframes[framename].fonttime:SetFont(media:Fetch("font", self.db.profile.mainfont) , 55, "OUTLINE")
	self.allframes[framename].fonttime:SetTextColor(0, 0.7, 0)
end

function UnrealTimers:createFrame(frame_id, i)
	local framename = 'frame'..frame_id
	self.allframes[framename] = CreateFrame("Frame", framename, self.allframes)
	self.allframes[framename]:SetPoint("TOPLEFT", 0, -self.db.profile.frameheight*(i-1)-10)
	self.allframes[framename]:SetSize(300, self.db.profile.frameheight)
	self.allframes[framename]:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8"})
	self.allframes[framename]:SetBackdropColor(0, 0, 0, 0.2)
	
	self.allframes[framename].tex = self.allframes[framename]:CreateTexture(nil, "BACKGROUND")
	self.allframes[framename].tex:SetPoint("LEFT", 0, 0)
	--if zone_data[self.db.profile.currentZone] ~= nil then
		--self.allframes[framename].tex:SetTexture(zone_data[self.db.profile.currentZone][i]['Texture'])
	--else
		self.allframes[framename].tex:SetTexture(0,0,0)
	--end
	self.allframes[framename].tex:SetSize(64*1.4, 32*1.4)
	self.allframes[framename].tex:Hide()
	
	self:FrameName(frame_id, i, framename)
	self:FrameTime(frame_id, i, framename)
end

function UnrealTimers:FrameName(frame_id, i, framename)
	self.allframes[framename].fontname = self.allframes[framename]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.allframes[framename].fontname:SetPoint("LEFT", 70, 0)
	self.allframes[framename].fontname:SetText(framename)
	self.allframes[framename].fontname:SetFont("Fonts\\FRIZQT__.ttf" , 15, "OUTLINE")
end

function UnrealTimers:FrameTime(frame_id, i, framename)
	self.allframes[framename].fonttime = self.allframes[framename]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.allframes[framename].fonttime:SetPoint("RIGHT", -5, 0)
	self.allframes[framename].fonttime:SetText(0.00)
	self.allframes[framename].fonttime:SetFont("Fonts\\FRIZQT__.ttf" , 15, "OUTLINE")
end

function UnrealTimers:StartTime()
	if self.timerrun == false then
		self.currentCheckPoint = 1
		self.db.profile.startcheck = 0
		local localtime =  GetTime()
		self.GoTime = GetTime()
		self.timerrun = true
		self.allframes['frame1']:SetBackdropColor(0, 0, 1, 0.2)
	end
end

function UnrealTimers:eventlog(event, ...)	
	-- local isinarray = self:FindValue(self.db.profile.currentZone , zone_ids)
	-- if isinarray then
		
		-- if event == 'ENCOUNTER_START' then
			-- local creatureid = ...
			-- local thetime = GetTime()
			-- local thedate = date()
			-- local name = UnitName("player")
			-- local realmName = GetRealmName()
			-- local playername = name..'-'..realmName
			-- SetMapToCurrentZone()
			-- local posX, posY = GetPlayerMapPosition("player")
			-- local mapid = GetCurrentMapAreaID()
			-- local subzonemapname = GetSubZoneText()
			-- local datas = thedate..' '..thetime..' '..event..' '..playername..' '..posX..' '..posY..' '..mapid..' '..subzonemapname..' '..creatureid..' '..'unknown'
			-- table.insert(self.db.global.datalogs, datas) 
			-- --print(datas)
		-- elseif event == 'ENCOUNTER_END' then
			-- local creatureid, _, _, _, iskill = ...
			-- local thetime = GetTime()
			-- local thedate = date()
			-- local name = UnitName("player")
			-- local realmName = GetRealmName()
			-- local playername = name..'-'..realmName
			-- SetMapToCurrentZone()
			-- local posX, posY = GetPlayerMapPosition("player")
			-- local mapid = GetCurrentMapAreaID()
			-- local subzonemapname = GetSubZoneText()
			-- local datas = thedate..' '..thetime..' '..event..' '..playername..' '..posX..' '..posY..' '..mapid..' '..subzonemapname..' '..creatureid..' '..'unknown'..' '..iskill
			-- table.insert(self.db.global.datalogs, datas)
			-- --print(datas)			
		-- elseif event == 'PLAYER_REGEN_DISABLED' then
			-- local thetime = GetTime()
			-- local thedate = date()
			-- local name = UnitName("player")
			-- local realmName = GetRealmName()
			-- local playername = name..'-'..realmName
			-- SetMapToCurrentZone()
			-- local posX, posY = GetPlayerMapPosition("player")
			-- local mapid = GetCurrentMapAreaID()
			-- local subzonemapname = GetSubZoneText()
			-- local datas = thedate..' '..thetime..' '..event..' '..playername..' '..posX..' '..posY..' '..mapid..' '..subzonemapname
			-- table.insert(self.db.global.datalogs, datas) 
			-- --print(datas)
		-- elseif event == 'PLAYER_REGEN_ENABLED' then
			-- local thetime = GetTime()
			-- local thedate = date()
			-- local name = UnitName("player")
			-- local realmName = GetRealmName()
			-- local playername = name..'-'..realmName
			-- SetMapToCurrentZone()
			-- local posX, posY = GetPlayerMapPosition("player")
			-- local mapid = GetCurrentMapAreaID()
			-- local subzonemapname = GetSubZoneText()
			-- local datas = thedate..' '..thetime..' '..event..' '..playername..' '..posX..' '..posY..' '..mapid..' '..subzonemapname
			-- table.insert(self.db.global.datalogs, datas) 
			-- --print(datas)
		-- elseif event == 'COMBAT_LOG_EVENT_UNFILTERED' then
			-- local localtime, event, hide,srcGUID,srcName,srcF1,srcF2,destGUID = ...
			-- --print(destGUID)
			-- if event == 'UNIT_DIED' then
				-- --print('died '..destGUID)
				-- local thetime = GetTime()
				-- local thedate = date()
				-- local name = UnitName("player")
				-- local realmName = GetRealmName()
				-- local playername = name..'-'..realmName
				-- SetMapToCurrentZone()
				-- local posX, posY = GetPlayerMapPosition("player")
				-- local mapid = GetCurrentMapAreaID()
				-- local subzonemapname = GetSubZoneText()
				-- local datas = thedate..' '..thetime..' '..'UNIT_DIED'..' '..playername..' '..posX..' '..posY..' '..mapid..' '..subzonemapname..' '..destGUID
				-- table.insert(self.db.global.datalogs, datas) 
				-- --print(datas)
				-- for i, guid in ipairs(self.unitisinfight) do
					-- if destGUID == guid then
						-- table.remove(self.unitisinfight, i)
						-- --print('was in database')
					-- end
				-- end
			-- elseif destGUID ~= '' then	
				-- local findtheshit = string.find(destGUID, "Player")
				-- local findtheshit2 = string.find(destGUID, "Pet")
				-- if findtheshit then
					-- --print('true')
				-- elseif findtheshit2 then
					-- --print('true')
				-- else
					-- local isinarray = self:FindValue(destGUID , self.unitisinfight)
					-- if not isinarray then
						-- table.insert(self.unitisinfight, destGUID) 
						-- local thetime = GetTime()
						-- local thedate = date()
						-- local name = UnitName("player")
						-- local realmName = GetRealmName()
						-- local playername = name..'-'..realmName
						-- SetMapToCurrentZone()
						-- local posX, posY = GetPlayerMapPosition("player")
						-- local mapid = GetCurrentMapAreaID()
						-- local subzonemapname = GetSubZoneText()
						-- local datas = thedate..' '..thetime..' '..'UNIT_INFIGHT'..' '..playername..' '..posX..' '..posY..' '..mapid..' '..subzonemapname..' '..destGUID
						-- table.insert(self.db.global.datalogs, datas) 
						-- --print(datas)
					-- end
				-- end
				
			-- end
		-- end
	-- end
end


function isoverninenine(runningtime)
	if runningtime < 9.999 then 
		return true 
	else 
		return false
	end 
end

function UnrealTimers.mainframe:OnEvent(event, ...)
	if event == 'ZONE_CHANGED_NEW_AREA' then
		UnrealTimers:zone_changed()
	elseif event == 'ENCOUNTER_START' then
		UnrealTimers:boss_start(...)
	elseif event == 'ENCOUNTER_END' then
		UnrealTimers:boss_end(...)
	elseif event == 'PLAYER_REGEN_DISABLED' then
		UnrealTimers:check_start()
	elseif event == 'PLAYER_REGEN_ENABLED' then
	elseif event == 'COMBAT_LOG_EVENT_UNFILTERED' then
	
	end
end

function UnrealTimers:OnOptionCreate()
	-- if UnrealTimers.db.profile.lock then
		-- UnrealTimers.mainframe:EnableMouse(false)
	-- end
	-- self.options = {
		-- type = 'group',
		-- name = GetAddOnMetadata("UnrealTimers", "Title"),
		-- get = function(info)
			-- return self.db.profile[info[#info]]
		-- end,
		-- args = {
			-- general = {
				-- type = "group",
				-- name = L["General"],
				-- order = 1,
				-- args = {
					-- lock = {
						-- type = "toggle",
						-- name = L["Lock position"],
						-- order = 1,
						-- set = function(info, value)
							-- self.db.profile.lock = value
							-- if value then
								-- self.mainframe:EnableMouse(false)
								--self.bg:Hide()
								--self.header:Hide()
							-- else
								-- self.mainframe:EnableMouse(true)
								--self.bg:Show()
								--self.header:Show()
							-- end
						-- end,
					-- },
					-- mainfont = {
						-- type = "select",
						-- name = L["Font"],
						-- order = 4,
						-- values = media:List("font"),
						-- itemControl = "DDI-Font",
						-- get = function()
							-- for i, v in next, media:List("font") do
								-- if v == self.db.profile.mainfont then return i end
							-- end
						-- end,
						-- set = function(info, value)
							-- local list = media:List("font")
							-- local font = list[value]
							-- self.db.profile.mainfont = font
							-- self.allframes['overalltime'].fonttime:SetFont(media:Fetch("font", font), 55, "OUTLINE")
						-- end,
					-- },
					-- frameheight = {
						-- type = "range",
						-- name = L["height"],
						-- order = 2,
						-- max = 80,
						-- min = 6,
						-- step = 1,
						-- set = function(info, value)
							-- self.db.profile.frameheight = value
							--self.allframes['overalltime']:SetPoint("TOPLEFT", 0, -self.db.profile.frameheight*(6-1))
							--self.allframes['overalltime']:SetSize(300, self.db.profile.frameheight)
						-- end,
					-- },
					--currentZone = {
					--},
				-- }
			-- }
		--}
	--}
	--self.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	--LibStub("AceConfig-3.0"):RegisterOptionsTable("UnrealTimers", UnrealTimers.options)
	
	--LibStub("AceConfigDialog-3.0"):AddToBlizOptions("UnrealTimers", "UnrealTimers", nil, "general")
	--LibStub("AceConfigDialog-3.0"):AddToBlizOptions("UnrealTimers", "Profiles", "UnrealTimers", "profiles")
end
